<?php
   if(!defined('ANTIBUG')) exit;
   
   require_once(PLOUF_PATH.'Database.php');
   
   /*
    * Controller to manage the payload list you see when you enter the administration
    * panel.
    */
   class extensions extends WebModule
   {
      private $Database;
      
      public function __construct()
      {
         parent::__construct();
         $this->Database=Database::getInstance();
      }
      
      /*
      * We calculate the list of payloads and load them onto the panel
      */
      public function main()
      {
         /* PAYLOAD PART */
         $payloads=array();
         $scan=scandir(PAYLOADS_REPOSITORY);//scan the payload directory for payloads
         foreach($scan as $item)
         {
            //we gather only php files
            if(is_file(PAYLOADS_REPOSITORY.$item) && strrchr($item, '.')=='.php')
            {
               include_once(PAYLOADS_REPOSITORY.$item);
               $class=explode('.', $item);
               $class=$class[0];
               $payload=new $class();
               // we check that the payload implements the Payload Interface
               if(in_array('PayloadInterface',class_implements($payload)))
               {
                  //an array containing info about the payload
                  $data = array('name'=>htmlentities($payload->own->name),
                     'description'=>htmlentities($payload->description),
                     'isInstall'=>$this->isPayloadInstalled($payload->own->name)//check if the payload is installed or not
                     );
                     
                  if($payload->auto_load==true)
                     $data=array_merge($data, array('isAutoLoad' => $this->isAutoLoad($payload->own->name)));//check if the payload has to load automatically or not
                     
                  array_push($payloads, $data);//we add the payload to our container
                  unset($data);
               }
               
               unset($class);
               unset($payload);
            }
         }
         
         //we give to smarty an array containing the list of payload
         if(!empty($payloads))
            $this->setRenderData('payloads',$payloads);
         
         
         /* PLUGINS PART */
         $plugins=array();
         $scan=scandir(PLUGINS_REPOSITORY);//scan the plugin directory for plugins
         foreach($scan as $item)
         {
            if(is_file(PLUGINS_REPOSITORY.$item) && strrchr($item, '.')=='.php')
            {
               include_once(PLUGINS_REPOSITORY.$item);
               $class=explode('.', $item);
               $class=$class[0];
               $plugin=new $class();
               // we check that the payload implements the Payload Interface
               if(in_array('PluginInterface',class_implements($plugin)) && isset($plugin->own->name))
               {
                  //an array containing info about the payload
                  $data = array('name'=>htmlentities($plugin->own->name),
                     'description'=>htmlentities($plugin->description),
                     'isInstall'=>$this->isPluginInstalled($plugin->own->name)//check if the payload is installed or not
                     );
                     
                  array_push($plugins, $data);//we add the payload to our container
                  unset($data);
               }
               
               unset($class);
               unset($plugin);
            }
         }
         
         if(!empty($plugins))
            $this->setRenderData('plugins', $plugins);
      }
      
      /*
       * Verify if a payload is installed
       * @access  private
       * @param   string   $payload_name  the payload name
       * @return  bool  true / false   true if the payload is installed, false if not
       */
      private function isPayloadInstalled($payload_name)
      {
         $payload_name=mysql_real_escape_string($payload_name);
         
         $SQLQuery="SELECT name FROM payload WHERE name='$payload_name'";
         $query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__, __LINE__);
         
         if($this->Database->numRows($query)!=0)
            return true;
         else
            return false;
      }
      
      /*
       * Verify if a payload has to be automatically loaded
       * @access  private
       * @param   string      $payload_name  the payload name
       * @return  integer     1 / -1   1 if yes, -1 if no
       */
      private function isAutoLoad($payload_name)
      {
         $payload_name=mysql_real_escape_string($payload_name);
         
         $SQLQuery="SELECT name FROM payload WHERE name='$payload_name' AND is_automatic=1";
         $query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__, __LINE__);
         
         if($this->Database->numRows($query)!=0)
            return 1;//the payload is automatically loaded
         else
            return -1;//the payload isn't automatically loaded
      }
      
      /*
       * Check if a plugin has been installed
       * @access  private
       * @param   string   $plugin_name   the name of the plugin to check
       * @return  bool     true if yes, false if no
       */
      private function isPluginInstalled($plugin_name)
      {
         $plugin_name=mysql_real_escape_string($plugin_name);
         
         $SQLQuery="SELECT name FROM plugin WHERE name='$plugin_name'";
         $query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__, __LINE__);
         
         if($this->Database->numRows($query)!=0)
            return true;
         else
            return false;
      }
   }
?>
