<?php
   if(!defined('ANTIBUG')) exit;
   
   include_once(PLOUF_PATH.'Database.php');
   
   /*
    * This is the controller for the payload module. It's part of the interface
    * so it extends WebModule.
    */
   class payload extends WebModule
   {
      public function __construct()
      {
         parent::__construct();
      }
      
      public function main(){}
      
      /*
       * Install a new payload
       * 
       * Uses $_GET['name'] to gather the payload to install name
       * @access public
       */
      public function install()
      {
         $payload_name=$this->http->getCleanString('name');//we get the plugin name
         //we check if the payload exists
         if(file_exists(PAYLOADS_REPOSITORY.$payload_name.'.php'))
         {
            require_once(PAYLOADS_REPOSITORY.$payload_name.'.php');
            if(class_exists($payload_name) && in_array('PayloadInterface',class_implements($payload_name)))
            {
               $payload=new $payload_name();
               $payload->install();
               
               $Database=Database::getInstance();
               // we insert a new line in our database to say that the payload has been installed and can now be used
               $SQLQuery="INSERT INTO payload (name, is_automatic) VALUES ('$payload_name', '0')";
               $Query=$Database->query($SQLQuery) or $Database->dieError(__FILE__, __LINE__);
               echo 'Payload successfully installed';
            }
            else
               die('Payload does not implement the PayloadInterface');
         }
         else
            die('Payload does not exists');
      }
      
      /*
       * Remove a installed payload
       * 
       * Uses $_GET['name'] to gather the payload to remove name
       * @access public
       */
      public function remove()
      {
         $payload_name=$this->http->getCleanString('name');
         //we check that the payload exists
         if(file_exists(PAYLOADS_REPOSITORY.$payload_name.'.php'))
         {
            include_once(PAYLOADS_REPOSITORY.$payload_name.'.php');
            
            if(class_exists($payload_name) && in_array('PayloadInterface',class_implements($payload_name)))
            {
               $payload=new $payload_name();
               $payload->remove();//can the payload remove() function
               
               $Database=Database::getInstance();
               //we remove the line in the database saying that the payload can be use
               $SQLQuery="DELETE FROM payload WHERE name='$payload_name'";
               $Query=$Database->query($SQLQuery) or $Database->dieError(__FILE__, __LINE__);
               echo 'Payload successfully removed';
            }
            else
               die('Payload does not implement PayloadInterface');
         }
         else
            die('Payload does not exists');
      }
      
      /*
       * Set a payload to be load automatically load or not
       * 
       * Uses $_GET['name'] to gather the payload to update name
       * @access public
       */
      public function autoload()
      {
         $payload_name=$this->http->getCleanString('name');
         $payload_name=mysql_real_escape_string($payload_name);
         
         $Database=Database::getInstance();
         $payload_name=mysql_real_escape_string($payload_name);
         $SQLQuery="SELECT is_automatic FROM payload WHERE name='$payload_name'";
         $Query=$Database->query($SQLQuery) or $Database->dieError(__FILE__, __LINE__);
         //we check that the payload is present in our database
         if($Database->numRows($Query))
         {
            $is_automatic=$Database->fetchResult($Query, 0);
            if($is_automatic==0)
               $SQLQuery="UPDATE payload SET is_automatic='1' WHERE name='$payload_name'";//we set the payload to be load automatically
            else
               $SQLQuery="UPDATE payload SET is_automatic='0' WHERE name='$payload_name'";//we set the payload NOT to be load automatically
            $Database->query($SQLQuery) or $Database->dieError(__FILE__, __LINE__);
         }
         else
            die('Payload does not exists');
      }
      
      /*
       * Detach a zombie from a payload
       * 
       * uses $_GET['zombie_ip'] to get the ip of the the zombie
       * uses $_GET['payload_name'] to get the name of the payload to detach the zombie from
       * @access public
       */
      public function detach()
      {
         $Database=Database::getInstance();
         $zombie_ip=$this->http->getCleanString('zombie_ip');
         $payload_name=$this->http->getCleanString('payload_name');
         
         $SQLQuery="SELECT id FROM payload WHERE name='$payload_name'";
         $Query=$Database->query($SQLQuery) or $Database->dieError(__FILE__, __LINE__);
         if($Query && $Database->numRows($Query)!=0)
         {
            $payload=$Database->fetchAssoc($Query);
            $payload=intval($payload['id']);
            
            $SQLQuery="SELECT id FROM zombie WHERE ip='$zombie_ip'";
            $Query=$Database->query($SQLQuery) or $Database->dieError(__FILE__, __LINE__);
            if($Query && $Database->numRows($Query)!=0)
            {
               $zombie=$Database->fetchAssoc($Query);
               $zombie=intval($zombie['id']);
               
               $SQLQuery="DELETE FROM zombie_to_payload WHERE zombie_id='$zombie' AND payload_id='$payload'";
               $Database->query($SQLQuery) or $Database->dieError(__FILE__, __LINE__);
               echo "Zombie successufuly detached from payload";
            }
         }
      }
   }
   
?>
