<?php
	if(!defined('ANTIBUG')) exit;
	/*
	 * This class manages the sessions
	 */
	class SessionObject
	{
		static private $instance=null;
		static private $sessionID;
		
		private function __construct()
		{
			session_start();
			self::$sessionID=session_id();
		}
		
		static public function getInstance()
		{
			if(self::$instance==null)
			{
				self::$instance=new SessionObject();			
			}
				
			return self::$instance;
		}
		
		public function __get($name)
		{
			if(isset($_SESSION[$name]))
			{
				return $_SESSION[$name];
			}
			else
			{
				return false;
			}	
		}
		
		public function __set($name,$value)
		{
			$_SESSION[$name]=$value;
		}
		
		public function __unset($name)
		{
			unset($_SESSION[$name]);
		}
		
		/*
		 * Verify a user login and password, it they are correct it logs him.
		 * 
		 * @return	bool	True if the access are correct, false if not
		 */
		public function loginUser($username,$password)
		{
			if( ($username == USER_LOGIN) && ($password == USER_PASSWORD) )
			{
				$this->loggedIn=true;
				return true;
			}
			else
			{
				return false;
			}
		}
		
		/*
		 * Return true if the user is logged in, false if not
		 */
		public function isLoggedIn()
		{
			return $this->loggedIn;
		}
		
		/*
		 * Erase the session and disconnect the user
		 */
		public function disconnectUser()
		{
			foreach($_SESSION as $key=>$value)
			{
				unset($_SESSION[$key]);
			}
			session_destroy();						
		}
	}

?>
