<?php
   if(!defined('ANTIBUG')) exit;
   
   include_once(LIB_PATH.'modules/ControlModule.php');
   include_once(PLOUF_PATH.'Database.php');
   
   interface PluginInterface
   {
      public function install();
      public function remove();
      public function run();
      public function main();
   }
   
   class PluginModule extends ControlModule
   {
      public $description;//description of the plugin
      public $proc_name;//the processus name for the framework
      public $renderData=array();//data to assign in smarty
      
      public function __construct()
      {
         parent::__construct();
         $this->setRenderData('BROWSERRIDER_URL', BASE_URL);
      }
      
      /*
       * Assign data to render with Smarty
       * @access  public
       * @param   string   $name name of the data to render
       * @param   mixed $data    to render
       */
      public function setRenderData($name, $data)
      {
         $this->renderData = array_merge($this->renderData, array($name => $data));
      }
      
      /*
       * Return the data to assign by smarty
       * @access  public
       */
      public function getRenderData()
      {
         return $this->renderData;
      }
   }

?>
