<?php
   if(!defined('ANTIBUG')) exit;
   
   include_once(LIB_PATH.'modules/AuthModule.php');
   include_once(LIB_PATH.'modules/WebModule.php');
   // we check if the module exists and can be load
   if(isset($_GET['module']))
      (file_exists(PATH_CONTROLLERS.$_GET['module'].'.php') or file_exists(PAYLOADS_REPOSITORY.$_GET['module'].'.php') or file_exists(PLUGINS_REPOSITORY.$_GET['module'].'.php')) ? $module = $_GET['module'] : $module = 'login';
   else
      $module = 'login';
   
   // we check if the user has the right to access this module
   $AuthModule = new AuthModule();
   if($AuthModule->isAuthorizeToAccess($module)==false)
      die("Unauthorize to access this module");
   unset($AuthModule);
   
   // we load the module
   if(file_exists(PATH_CONTROLLERS.$module.'.php'))
      include_once(PATH_CONTROLLERS.$module.'.php');
      
   else if(file_exists(PLUGINS_REPOSITORY.$_GET['module'].'.php'))
      include_once(PLUGINS_REPOSITORY.$_GET['module'].'.php');
      
   else if(file_exists(PAYLOADS_REPOSITORY.$_GET['module'].'.php'))
      include_once(PAYLOADS_REPOSITORY.$module.'.php');
      
   else
      die('cannot find module');
      
   $class = new $module();
   
   // we check that the class extends one of the two Module super class
   if(! (is_subclass_of($class, 'WebModule') or is_subclass_of($class, 'PayloadModule') or is_subclass_of($class, 'PluginModule')))
      die("Error: '$module' is not a subclass of 'WebModule' or 'PayloadModule' or 'PluginModule'");
   
   // we check if the process exists and can be called
   (isset($_GET['process']) && method_exists($module, $_GET['process'])) ? $process = $_GET['process'] : $process = 'main';
   $class->$process();
   $class->proc_name=$process;
   
   include_once(LIB_PATH.'views/panel.view.php');
   $SmartyView = new InterfaceView($class);
   
   if(is_subclass_of($class, 'WebModule'))
      $SmartyView->render();//if the class is a WebModule
   else if(is_subclass_of($class, 'PayloadModule'))
      $SmartyView->renderPayloadTemplate();//the class is a PayloadModule
   else
      $SmartyView->renderPluginTemplate();//the class is a plugin
?>
