<?php
   if(!defined('ANTIBUG')) exit;
   
   include_once(LIB_SMARTY.'Smarty.class.php');
   /*
    * Display payloads using smarty
    */
   class PayloadView extends Smarty
   {
      private $payload;
      
      public function __construct(PayloadModule $payload)
      {
         $this->Smarty();
         $this->payload = $payload;
         //configure smarty
         $this->template_dir=PAYLOADS_JAVASCRIPT;
         $this->compile_dir=PAYLOADS_TEMPLATES_COMPILED;
      }
      
      /*
       * Render dans display the payload
       */
      public function render()
      {
         //we display librairies if required
         if(!empty($this->payload->libraries))
         {
            foreach($this->payload->libraries as $lib)
            {
               if(is_string($lib) && file_exists(PAYLOADS_LIBRARIES.$lib.'.js'))
               {
                  include_once('JSMin.php');
                  $library_content=file_get_contents(PAYLOADS_LIBRARIES.$lib.'.js');
                  echo JSMin::minify($library_content)."\n";
               }
            }
         }
         
         //assign data to render to the template
         $data=$this->payload->getRenderData();
         if(!empty($data)) {
            foreach($data as $moduleVar=>$moduleValue) {
               $this->assign($moduleVar, $moduleValue);
            }
         }
         //display the template
         $tplfile=$this->payload->own->name.'.js';
         /* we obfuscate the payload if required */
         if($this->payload->obfuscator!=null)
         {
            $obfuscator = $this->payload->obfuscator;
            if(file_exists(OBFUSCATOR_REPOSITORY.$obfuscator.'.php'))//we check that the obfuscator exists
            {
               include_once(OBFUSCATOR_REPOSITORY.$obfuscator.'.php');
               
               if(class_exists($obfuscator))//we check the class name
               {
                  $smarty_output = $this->fetch($tplfile);
                  if($this->payload->obfuscator_options!=null) {
                     $obs=new $obfuscator($smarty_output, $this->payload->obfuscator_options);//the payload has some options
                  } else {
                     $obs=new $obfuscator($smarty_output);
                  }
                  echo $obs->obfuscate();//we display our obfuscated payload
                  return;
               }
            }
         }
         else
         {
            /* If the payload is not obfuscated we minify it */
            if($this->payload->minify==true)
            {
               include_once(PLOUF_PATH.'JSMin.php');
               $smarty_output = $this->fetch($tplfile);
               echo JSMin::minify($smarty_output)."\n";
            }
            else
            {
               $this->display($tplfile);//we display the payload with smarty without any compression
            }
         }
      }
   }
?>
